#define BLACK      0
#define BLUE       1
#define GREEN      2
#define CYAN       3
#define RED        4
#define MAGENTA    5
#define BROWN      6
#define LGRAY      7
#define GRAY       8
#define LBLUE      9
#define LGREEN    10
#define LCYAN     11
#define LRED      12
#define LMAGENTA  13
#define YELLOW    14
#define WHITE     15

int _scanbuf[200][2];

void initgraph() {
  _asm{
    mov   eax, 13h
    int   10h
  };
}

void closegraph() {
  _asm{
    mov   eax, 3
    int   10h
  };
}

void putpixel (int x, int y, char c) {
  _asm{
    mov   edi, y
    shl   edi, 6
    mov   eax, edi
    lea   edi, [0A0000h+eax*4+edi]
    add   edi, x
    mov   al, c
    stosb
  };
}

void line (int x1, int y1, int x2, int y2, char color) {
  int sx, sy, dx1, dy1, dx2, dy2, x, y, m, n, k=0, cnt;

  sx = x2-x1;
  sy = y2-y1;

  if (sx > 0) dx1 = 1;
  else if (sx < 0) dx1 = -1;
  else dy1 = 0;

  if (sy > 0) dy1 = 1;
  else if (sy < 0) dy1 = -1;
  else dy1 = 0;

  m = abs (sx);
  n = abs (sy);

  dx2 = dx1;
  dy2 = 0;

  if (m < n) {
    m = abs (sy);
    n = abs (sx);
    dx2 = 0;
    dy2 = dy1;
  };

  x = x1; y = y1;
  cnt = m+1;
  while (cnt--) {
    putpixel (x, y, color);
    k += n;
    if (k < m) {
      x += dx2;
      y += dy2;
    }
    else {
      k -= m;
      x += dx1;
      y += dy1;
    };
  };
}

void _scanline (x1, y1, x2, y2)
  int x1, y1, x2, y2;		{
  int sx, sy, dx1, dy1, dx2, dy2, x, y, m, n, k=0, cnt;

  sx = x2-x1;
  sy = y2-y1;

  if (sx > 0) dx1 = 1;
  else if (sx < 0) dx1 = -1;
  else dy1 = 0;

  if (sy > 0) dy1 = 1;
  else if (sy < 0) dy1 = -1;
  else dy1 = 0;

  m = abs (sx);
  n = abs (sy);

  dx2 = dx1;
  dy2 = 0;

  if (m < n) {
    m = abs (sy);
    n = abs (sx);
    dx2 = 0;
    dy2 = dy1;
  };

  x = x1; y = y1;
  cnt = m+1;
  while (cnt--) {
    if ((y >= 0) && (y < 200)) {
      if (_scanbuf[y][0] > x) _scanbuf[y][0] = x;
      if (_scanbuf[y][1] < x) _scanbuf[y][1] = x;
    };
    k += n;
    if (k < m) {
      x += dx2;
      y += dy2;
    }
    else {
      k -= m;
      x += dx1;
      y += dy1;
    };
  };
}

void fillpoly (x1, y1, x2, y2, x3, y3, x4, y4, color)
  int x1, y1, x2, y2, x3, y3, x4, y4;
  char color;						{
  int i, ymin, ymax, xl, xr;
  
  ymin = ymax = y1;
  if (ymin > y2) ymin = y2;
  if (ymin > y3) ymin = y3;
  if (ymin > y4) ymin = y4;
  if (ymax < y2) ymax = y2;
  if (ymax < y3) ymax = y3;
  if (ymax < y4) ymax = y4;

  if (ymin < 0) ymin = 0;
  if (ymax > 199) ymax = 0;
  if ((ymin > 199) || (ymax < 0)) return;

  for (i=0;i<200;i++) {
    _scanbuf[i][0] = 320;
    _scanbuf[i][1] = -1;
  };
  _scanline (x1, y1, x2, y2);
  _scanline (x2, y2, x3, y3);
  _scanline (x3, y3, x4, y4);
  _scanline (x4, y4, x1, y1);

  for (i=ymin;i<=ymax;i++) {
    if ((xl = _scanbuf[i][0]) < 0) xl = 0;
    if ((xr = _scanbuf[i][1]) > 319) xr = 319;
    if ((xl > 319) || (xr < 0)) continue;
    line (xl, i, xr, i, color);
  };
}

void setpal (char *pal) {
  _asm{
    mov   esi, pal
    mov   ecx, 768
    cld
    mov   dx, 3C8h
    xor   al, al
    out   dx, al
    inc   dx
    rep   outsb
  };
}
